﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace mPCIe_DIO_24s
{
    public partial class Winform_MotorCtrlConfig : Form
    {
        public Winform_MotorCtrlConfig()
        {
            InitializeComponent();
        }

        private void motor_ctrl_config_form_Load(object sender, EventArgs e)
        {
            string[] freq_unit_string = new string[] {"Hz", "KHz", "MHz"};
            string[] mot_direction_string = new string[] { "Forward", "Reverse" };
            
            cbFreqUnit.Items.AddRange(freq_unit_string);
            cbMotDir.Items.AddRange(mot_direction_string);

            cbFreqUnit.SelectedIndex = 1;
            cbMotDir.SelectedIndex = 0;
        }

        /// <summary>
        /// Allow only numeric values
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void tbBaseFreq_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = !char.IsDigit(e.KeyChar) && !char.IsControl(e.KeyChar);
        }

        private void btOk_Click(object sender, EventArgs e)
        {
            eConfigParam direction;
            float base_freq_khz;

            // TODO Get Direction, Base Frequency, offset count value and pass it to main UI (Form1)            
            if (cbMotDir.SelectedIndex == 0)
            {
                direction = eConfigParam.eDirForward;
            }
            else
            {
                direction = eConfigParam.eDirReverse;
            }

            if(cbFreqUnit.SelectedIndex == 0)   //Hz
            {                
                base_freq_khz = (float) Int32.Parse(tbBaseFreq.Text) / 1000;
            }                
            else if (cbFreqUnit.SelectedIndex == 1) //KHz
            {
                base_freq_khz = (float)Int32.Parse(tbBaseFreq.Text);
            }
            else if (cbFreqUnit.SelectedIndex == 2) //MHz
            {
                base_freq_khz = (float)Int32.Parse(tbBaseFreq.Text) * 1000;
            }
            this.Close();
        }        
    }
}
