﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace mPCIe_DIO_24s
{
    public partial class Winform_PulseTrainConfig : Form
    {
        public Winform_PulseTrainConfig()
        {
            InitializeComponent();
        }

        private void Winform_PulseTrainConfig_Load(object sender, EventArgs e)
        {
            string[] pulse_direction_string = new string[] { "Low", "High" };
            string[] time_unit_string = new string[] { "Sec", "mSec", "uSec" };

            cbPulseDir.Items.AddRange(pulse_direction_string);
            cbPulseDir.SelectedIndex = 0;
            cbPulseLenUnit.Items.AddRange(time_unit_string);
            cbPulseLenUnit.SelectedIndex = 1;
            cbTimeBwPulUnit.Items.AddRange(time_unit_string);
            cbTimeBwPulUnit.SelectedIndex = 1;
        }

        /// <summary>
        /// Allow only numeric values
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void tbPulseLength_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = !char.IsDigit(e.KeyChar) && !char.IsControl(e.KeyChar);
        }

        /// <summary>
        /// Allow only numeric values
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void tbNumOfPulses_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = !char.IsDigit(e.KeyChar) && !char.IsControl(e.KeyChar);
        }

        /// <summary>
        /// Allow only numeric values
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void tbTimeBwPulse_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = !char.IsDigit(e.KeyChar) && !char.IsControl(e.KeyChar);
        }

        private void btOk_Click(object sender, EventArgs e)
        {
            int pulse_len = 0, pulse_cnt = 0, time_bw_pulse = 0;
            float time_bw_pulse_msec = 0, pulse_len_msec = 0;

            eConfigParam pulse_dir = eConfigParam.eNone;

            //Validate the entered data
            if (tbPulseLength.Text == "")
            {
                MessageBox.Show("Please enter the Pulse Length");
            }
            else if (tbNumOfPulses.Text == "")
            {
                MessageBox.Show("Please enter the Number of pulses");
            }
            else if (tbTimeBwPulse.Text == "")
            {
                MessageBox.Show("Please enter the time between pulse value");
            }
            else
            {
                pulse_len = Int32.Parse(tbPulseLength.Text);
                pulse_cnt = Int32.Parse(tbNumOfPulses.Text);
                time_bw_pulse = Int32.Parse(tbTimeBwPulse.Text);

                if (cbPulseDir.SelectedIndex == 0)
                {
                    pulse_dir = eConfigParam.ePulseDirLow;
                }
                else if (cbPulseDir.SelectedIndex == 1)
                {
                    pulse_dir = eConfigParam.ePulseDirHigh;
                }
                /* Convert the Pulse length time value based on the selected index */
                if (cbPulseLenUnit.SelectedIndex == 0)
                {
                    // Sec
                    pulse_len_msec = pulse_len * 1000;
                }
                else if (cbPulseLenUnit.SelectedIndex == 1)
                {
                    //mSec
                    pulse_len_msec = pulse_len;
                }
                else if (cbPulseLenUnit.SelectedIndex == 2)
                {
                    //uSec
                    pulse_len_msec = (float)pulse_len / 1000;
                }

                /* Convert the time between pulse time value based on the selected index */
                if (cbTimeBwPulUnit.SelectedIndex == 0)
                {
                    // Sec
                    time_bw_pulse_msec = time_bw_pulse * 1000;
                }
                else if (cbTimeBwPulUnit.SelectedIndex == 1)
                {
                    //mSec
                    time_bw_pulse_msec = time_bw_pulse;
                }
                else if (cbTimeBwPulUnit.SelectedIndex == 2)
                {
                    //uSec
                    time_bw_pulse_msec = (float)time_bw_pulse / 1000;
                }                

                ucPinConfig.PulseTrainConfigUpdate(pulse_dir, pulse_len_msec, pulse_cnt, time_bw_pulse_msec);

                this.Close();
            }            
        }              
    }
}
